﻿// укажите имя драйвера Modbus в дереве проекта:
var gDriver = IR.GetDevice("Modbus TCP");

// укажите спиок графических элементов которые будут управлять указанными здесь битами регистров:
var gRegisters = [
   {item: IR.GetItem("Page 3").GetItem("Item 1"), tag:"16694", bit:0},  
/*   {item: IR.GetItem("Page 1").GetItem("Item 2"), tag:"16698", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 3"), tag:"16702", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 4"), tag:"16706", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 5"), tag:"16710", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 6"), tag:"16714", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 7"), tag:"16718", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 8"), tag:"16722", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 9"), tag:"16726", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 10"), tag:"16730", bit:0},
   
   {item: IR.GetItem("Page 1").GetItem("Item 11"), tag:"16734", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 12"), tag:"16738", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 13"), tag:"16742", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 14"), tag:"16746", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 15"), tag:"16750", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 16"), tag:"16754", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 17"), tag:"16758", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 18"), tag:"16762", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 19"), tag:"16766", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 20"), tag:"16770", bit:0},
   
   {item: IR.GetItem("Page 1").GetItem("Item 21"), tag:"16774", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 22"), tag:"16778", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 23"), tag:"16782", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 24"), tag:"16786", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 25"), tag:"16790", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 26"), tag:"16794", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 27"), tag:"16798", bit:0},  
   {item: IR.GetItem("Page 1").GetItem("Item 28"), tag:"16802", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 29"), tag:"16806", bit:0},
   {item: IR.GetItem("Page 1").GetItem("Item 30"), tag:"16810", bit:0},
    // элемент, регистр, бит регистра        */
];

//------------------------ рабочий код, не изменять ----------------------------
function SetBit(register, num)
{
   return register | (1 << num);
}

function Unset(register, num)
{
   return register & ~(1 << num);
}

function GetBit(register, num)
{
   return (register >> num) & 1;
}

// при нажатии на кнопку. this - указатель на элемент
function OnPress()
{
   for(var i = 0; i < gRegisters.length; i++)
   {
      if(gRegisters[i].item == this)
      {
         var register = gDriver.GetFeedback(gRegisters[i].tag);
         var new_val = 0;
                  
         if(this.Value == 0)
            new_val = Unset(register, gRegisters[i].bit);
         else
            new_val = SetBit(register, gRegisters[i].bit);
            
         gDriver.Set(gRegisters[i].tag, new_val);
         break;
      }
   } 
}

// при получении обратной связи
function OnRecieve(name, dec_value)
{
   for(var i = 0; i < gRegisters.length; i++)
   {
      if(gRegisters[i].tag == name)
      {
         //IR.Log(name);
         var val = GetBit(dec_value, gRegisters[i].bit);
         gRegisters[i].item.Value = val;
      }
   }
}

// регистрация кнопок
function RegisterButton()
{ 
   for(var i = 0; i < gRegisters.length; i++)
   {
      var item = gRegisters[i].item;
      IR.AddListener(IR.EVENT_ITEM_PRESS, item, OnPress, item);
   }
}

// регистрация обратной связи
function RegisterTagListener()
{
   IR.AddListener(IR.EVENT_TAG_CHANGE, gDriver, OnRecieve);
}

// функция, выполняющаяся по старту
function Start()
{
   RegisterButton();
   RegisterTagListener();
}
 
IR.AddListener(IR.EVENT_START,0, Start);